=== added file 'src/com/goldencode/p2j/ui/client/widget/GenericContainer.java'
--- src/com/goldencode/p2j/ui/client/widget/GenericContainer.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/widget/GenericContainer.java	2021-06-09 16:59:33 +0000
@@ -0,0 +1,79 @@
+package com.goldencode.p2j.ui.client.widget;
+
+import com.goldencode.p2j.ui.*;
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+
+/**
+ * This class is slightly more convenient replacement for
+ * {@link GenericWidget}.
+ *
+ */
+public class GenericContainer extends AbstractContainer<GuiOutputManager>
+         implements WidgetWithConfig<BaseConfig>
+{
+   public GenericContainer()
+   {
+      config.id = WidgetId.nextID();
+   }
+
+   /**
+    * The widget config. The application sets the {@link BaseConfig#widthChars}
+    * and {@link BaseConfig#heightChars} while laying out.
+    */
+   protected BaseConfig config = new BaseConfig();
+
+   @SuppressWarnings("unchecked")
+   @Override
+   public BaseConfig config()
+   {
+      return config;
+   }
+
+   /**
+    * Default no-op implementation.
+    */
+   @Override
+   public void initialize(/* @Nullable */ WidgetId id, BaseConfig cfg)
+   {
+      // no-op
+   }
+
+   /**
+    * Default no-op implementation.
+    */
+   @Override
+   public void afterConfigUpdate(BaseConfig beforeUpdate)
+   {
+      // no-op
+   }
+
+   @SuppressWarnings("null")
+   @Override
+   public GenericContainer add(Widget<GuiOutputManager> w)
+   {
+      super.add(w);
+      GuiOutputManager.instance().getRegistry().addWidget(w);
+      return this;
+   }
+
+   /**
+    * Draw children relative to this container location.
+    */
+   @Override
+   public void draw()
+   {
+      final NativeDimension d = physicalDimension();
+      final NativePoint p = physicalLocation();
+      final NativeRectangle clip = clipRectangle(p, d);
+   
+      GuiDriver<?, ?> gd = (GuiDriver<?, ?>) OutputManager.getDriver();
+      
+      /**
+       * Note: the lambda below cannot be replaced by the method reference.
+       * This causes synthetic access method creation.
+       */
+      gd.draw(p, clip, () -> super.draw());
+   }
+
+}
\ No newline at end of file

=== added file 'src/com/goldencode/p2j/ui/client/widget/GenericWidget.java'
--- src/com/goldencode/p2j/ui/client/widget/GenericWidget.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/widget/GenericWidget.java	2021-06-09 17:09:06 +0000
@@ -0,0 +1,75 @@
+package com.goldencode.p2j.ui.client.widget;
+
+import com.goldencode.p2j.ui.*;
+import com.goldencode.p2j.ui.client.*;
+
+/**
+ * This class is slightly more convenient replacement for
+ * {@link AbstractWidget}.
+ *
+ */
+public abstract class GenericWidget extends LightweightWidget
+         implements WidgetWithConfig<BaseConfig>
+{
+   public GenericWidget()
+   {
+      config.id = WidgetId.nextID();
+   }
+
+   /**
+    * The widget config. The application sets the {@link BaseConfig#widthChars}
+    * and {@link BaseConfig#heightChars} while laying out.
+    */
+   protected BaseConfig config = new BaseConfig();
+
+   @SuppressWarnings("unchecked")
+   @Override
+   public BaseConfig config()
+   {
+      return config;
+   }
+
+   @Override
+   public double height()
+   {
+      return config.heightChars;
+   }
+
+   @Override
+   public double width()
+   {
+      return config.widthChars;
+   }
+
+   /**
+    * This implementation is required by the {@link WidgetWithConfig} protocol,
+    * but is neither called or used for non-containers.
+    */
+   @Override
+   public void initialize(/* @Nullable */ WidgetId id, BaseConfig cfg)
+   {
+      // no-op
+   }
+
+   /**
+    * Default no-op implementation.
+    */
+   @Override
+   public void afterConfigUpdate(BaseConfig beforeUpdate)
+   {
+      // no-op
+   }
+
+   /**
+    * Set the widget dimensions. Default implementation changes the config
+    * fields.
+    * 
+    * @param width the new widget width
+    * @param height the new widget height
+    */
+   public void setSize(double width, double height)
+   {
+      config.widthChars = width;
+      config.heightChars = height;
+   }
+}
\ No newline at end of file

=== added file 'src/com/goldencode/p2j/ui/client/widget/HScrollBar.java'
--- src/com/goldencode/p2j/ui/client/widget/HScrollBar.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/widget/HScrollBar.java	2021-06-09 17:34:32 +0000
@@ -0,0 +1,443 @@
+package com.goldencode.p2j.ui.client.widget;
+
+import java.awt.event.*;
+
+import com.goldencode.p2j.ui.*;
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.gui.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+import com.goldencode.p2j.ui.client.gui.theme.*;
+import com.goldencode.p2j.ui.client.model.*;
+
+/**
+ * This class is a complete horizontal scrollbar implementation.
+ *
+ */
+public final class HScrollBar extends AbstractScrollBar
+{
+   /**
+    * The (only) constructor for this widget.
+    * 
+    * @param model the scrolling model.
+    */
+   public HScrollBar(ScrollModel model)
+   {
+      super(model);
+   }
+
+   @Override
+   protected void doDraw(GuiDriver<?, ?> gd, GuiColorResolver gc)
+   {
+      final NativeDimension dim = physicalDimension();
+      final int scrollBarWidth = dim.width;
+      final Theme theme = ThemeManager.getCurrentTheme();
+
+      // fill in scroll bar area
+      theme.drawScrollBarGauge(gd, gc, 0, 0, scrollBarWidth, dim.height, true /* isHorizontal */);
+
+      final int buttonLongDim = Math.min(scrollBarWidth / 2, theme.getScrollBarButtonHeight());
+
+      /**
+       * The length between the left and right buttons
+       */
+      final int interButtonLength = scrollBarWidth - 2 * buttonLongDim;
+
+      /**
+       * Check for the case the widget width is not enough for just two buttons.
+       * In this case neither buttons nor thumb should not be visible.
+       */
+      if (interButtonLength < 0)
+      {
+         return;
+      }
+
+      final int buttonShortDim = theme.getScrollBarButtonWidth();
+
+      /**
+       * We center the horizontal scrollbar vertically
+       */
+      final int buttonY = (dim.height - buttonShortDim) / 2;
+
+      // draw left/top button
+      ThemeManager.getCurrentTheme().drawScrollBarButton(gd, gc, 0, buttonY, buttonLongDim,
+               buttonShortDim, ScrollBar.Position.LEFT, true, true,
+               lastPressedPart == Part.LEFT_BUTTON, lastHoverPart == Part.LEFT_BUTTON);
+
+      // draw right/bottom button
+      final int thumbEndLimit = scrollBarWidth - buttonLongDim;
+      ThemeManager.getCurrentTheme().drawScrollBarButton(gd, gc, thumbEndLimit, buttonY,
+               buttonLongDim, buttonShortDim, ScrollBar.Position.RIGHT, true, true,
+               lastPressedPart == Part.RIGHT_BUTTON, lastHoverPart == Part.RIGHT_BUTTON);
+
+      final int thumbMinWidth = theme.getScrollBarThumbMinSize();
+      if (interButtonLength < thumbMinWidth)
+      {
+         /**
+          * Scrollbar is too narrow for any thumb to be drawn
+          */
+         return;
+      }
+
+      final int modelWidth = model.getWidth();
+      final int modelPosition = model.getPosition();
+
+      /**
+       * We must treat zero-width case specially to prevent division by zero. 
+       */
+      final boolean isDegeneratedCase = modelWidth == 0;
+
+      /**
+       * Note: we calculate the gap between the thumb and the bottom button
+       * instead of thumb size. Otherwise we can get the 1-pixel gap between the
+       * thumb and the button at the end of thumb travel, which is visible to the
+       * user. We prefer to get slightly incorrect thumb size, which is hardly
+       * seen with the naked eye.
+       */
+      int thumbEnd = thumbEndLimit;
+      if (!isDegeneratedCase)
+      {
+         thumbEnd -= (modelWidth - model.getLastVisible()) * interButtonLength / modelWidth;
+      }
+
+      int thumbPosX = buttonLongDim;
+      if (!isDegeneratedCase)
+      {
+         thumbPosX += interButtonLength * modelPosition / modelWidth;
+      }
+
+      int thumbWidth = thumbEnd - thumbPosX;
+
+      /**
+       * Test if the thumb is too narrow, try to handle this
+       */
+      final int thumbInflateNeeded = thumbMinWidth - thumbWidth;
+      if (thumbInflateNeeded > 0)
+      {
+         /**
+          * The 'true' calculated thumb width is to small to be usable, so we try
+          * to increase it.
+          */
+         /**
+          * Note: the check above guarantees, that the inter-button space here is wide enough
+          * to contain a thumb of a minimum thumb width.
+          */
+         thumbWidth = thumbMinWidth;
+         final int halfIncrease = thumbInflateNeeded / 2;
+         thumbPosX = Math.min(Math.max(thumbPosX - halfIncrease, 0), thumbEndLimit - thumbWidth);
+      }
+
+      final int thumbSize = theme.getScrollBarThumbWidth();
+
+      final boolean thumbPressed = lastPressedPart == Part.THUMB;
+      final boolean thumbHover = lastHoverPart == Part.THUMB;
+      final int thumbPosY = (dim.height - thumbSize) / 2;
+
+      theme.drawScrollBarThumb(gd, gc, thumbPosX, thumbPosY, thumbWidth, thumbSize, thumbPressed,
+               thumbHover, true);
+   }
+
+   @Override
+   public Dimension minimumSize()
+   {
+      CoordinatesConversion cc = screen().coordinates();
+      return new Dimension(cc.columnFromPixels(minLength()), cc.rowFromPixels(minWidth()));
+   }
+
+   @Override
+   public void mouseDragged(/* @Nullable */ MouseEvent e)
+   {
+      if (lastPressedPart != Part.THUMB)
+      {
+         /**
+          * Effectively disallow any other mouse operation after the
+          * mouse pointer was dragged not by the thumb. Allowing it
+          * may look a bit weird from the user stand point.
+          */
+         lastPressedPart = Part.NONE;
+         return;
+      }
+
+      assert e != null;
+
+      final NativeDimension dim = physicalDimension();
+      final int scrollBarWidth = dim.width;
+      final Theme theme = ThemeManager.getCurrentTheme();
+
+      final int buttonLongDim = Math.min(scrollBarWidth / 2, theme.getScrollBarButtonHeight());
+
+      /**
+       * The length between the left and right buttons
+       */
+      final int interButtonLength = scrollBarWidth - 2 * buttonLongDim;
+
+      /**
+       * Check for the case the widget width is not enough for two
+       * buttons and minimum thumb.
+       *
+       * FIXME: in this situation the drag start should nod be possible,
+       * so it is better replace the test by an assertion.
+       */
+      final int thumbMinWidth = theme.getScrollBarThumbMinSize();
+      if (interButtonLength < thumbMinWidth)
+      {
+         /**
+          * FIXME: in this situation the drag start should nod be
+          * possible, so it is better replace the return statement by
+          * an assertion.
+          */
+         return;
+      }
+
+      /**
+       * Note: we calculate the gap between the thumb and the right
+       * button instead of thumb size. Otherwise we can get the
+       * 1-pixel gap between the thumb and the button at the end of
+       * thumb travel, which is visible to the user. We prefer to get
+       * slightly incorrect thumb size, which is hardly seen with the
+       * naked eye.
+       */
+      final int modelPage = model.getPage();
+      final int modelWidth = model.getWidth();
+      final int modelPosition = model.getPosition();
+
+      /**
+       * We must treat zero-width case specially to prevent division by zero. 
+       */
+      final boolean isDegeneratedCase = modelWidth == 0;
+
+      final int thumbEndLimit = scrollBarWidth - buttonLongDim;
+      int thumbEnd = thumbEndLimit;
+      if (!isDegeneratedCase)
+      {
+         thumbEnd -= (modelWidth - modelPage - modelPosition) * interButtonLength / modelWidth;
+      }
+
+      int thumbPosX = buttonLongDim;
+      if (!isDegeneratedCase)
+      {
+         thumbPosX += interButtonLength * modelPosition / modelWidth;
+      }
+
+      int thumbWidth = thumbEnd - thumbPosX;
+
+      /**
+       * Test if the thumb is too narrow, try to handle this
+       */
+      final int thumbInflateNeeded = thumbMinWidth - thumbWidth;
+      if (thumbInflateNeeded > 0)
+      {
+         /**
+          * The 'true' calculated thumb width is to small to be usable, so we try
+          * to increase it.
+          */
+         /**
+          * Note: the check above guarantees, that the inter-button space here is wide enough
+          * to contain a thumb of a minimum thumb width.
+          */
+         thumbWidth = thumbMinWidth;
+      }
+
+      /**
+       * Rightmost horizontal position
+       */
+      int maxPosX = interButtonLength - thumbWidth;
+      int maxModelPosition = modelWidth - modelPage;
+      int offset = e.getX() - lastMousePos;
+      int newModelPosition = maxPosX > 0 ? lastModelPos + offset * maxModelPosition / maxPosX : 0;
+      model.setPosition(Math.min(maxModelPosition, Math.max(0, newModelPosition)));
+   }
+
+   /**
+    * Update the {@link #lastHoverPart} and {@link #highLightedRect} field values
+    * when the mouse position changes.
+    * 
+    * @param x
+    *        the X coordinate
+    * @param y
+    *        the Y coordinate
+    * @return see above.
+    */
+   @Override
+   protected void updateMouseHitInfo(int x, int y)
+   {
+      NativeDimension dim = physicalDimension();
+      NativePoint p = screenPhysicalLocation();
+      int localX = x - p.x;
+
+      int scrollBarWidth = dim.width;
+      if (localX < 0 || localX >= scrollBarWidth)
+      {
+         /**
+          * Mouse is out of widget horizontal bounds
+          */
+         lastHoverPart = Part.NONE;
+         highLightedRect = null;
+         return;
+      }
+
+      Theme theme = ThemeManager.getCurrentTheme();
+      int buttonLongDim = Math.min(scrollBarWidth / 2, theme.getScrollBarButtonHeight());
+
+      /**
+       * The length between the left and right buttons
+       */
+      int interButtonLength = scrollBarWidth - 2 * buttonLongDim;
+
+      /**
+       * Check for the case the widget width is not enough for just two buttons.
+       * In this case the buttons should not be visible, and the scrollbar is unusable.
+       */
+      if (interButtonLength < 0)
+      {
+         lastHoverPart = Part.NONE;
+         highLightedRect = null;
+         return;
+      }
+
+      // compute buttons size
+
+      int buttonShortDim = theme.getScrollBarButtonWidth();
+
+      int rectTop = (dim.height - buttonShortDim) / 2;
+
+      int localY = y - p.y;
+      if ((localY < rectTop) || (localY >= (rectTop + buttonShortDim)))
+      {
+         lastHoverPart = Part.NONE;
+         highLightedRect = null;
+         return;
+      }
+
+      /**
+       * Now the pointer is in the widget active area.
+       */
+      int rectLeft;
+      int rectRight;
+
+      if (localX < buttonLongDim)
+      {
+         // Left button
+         rectLeft = 0;
+         rectRight = buttonLongDim;
+         lastHoverPart = Part.LEFT_BUTTON;
+      }
+      else
+      {
+         final int thumbEndLimit = scrollBarWidth - buttonLongDim;
+         if (localX >= thumbEndLimit)
+         {
+            // Right button
+            rectLeft = thumbEndLimit;
+            rectRight = scrollBarWidth;
+            lastHoverPart = Part.RIGHT_BUTTON;
+         }
+         else
+         {
+            /**
+             * Pointer is between the buttons.
+             */
+            final int thumbMinWidth = theme.getScrollBarThumbMinSize();
+            if (interButtonLength < thumbMinWidth)
+            {
+               /**
+                * Scrollbar is too narrow for any thumb to be drawn
+                */
+               lastHoverPart = Part.NONE;
+               highLightedRect = null;
+               return;
+            }
+
+            int modelWidth = model.getWidth();
+            int modelPosition = model.getPosition();
+
+            /**
+             * We must treat zero-width case specially to prevent division by zero. 
+             */
+            boolean isDegeneratedCase = modelWidth == 0;
+
+            /**
+             * Note: we calculate the gap between the thumb and the bottom button
+             * instead of thumb size. Otherwise we can get the 1-pixel gap between the
+             * thumb and the button at the end of thumb travel, which is visible to the
+             * user. We prefer to get slightly incorrect thumb size, which is hardly
+             * seen with the naked eye.
+             */
+            int thumbEnd = thumbEndLimit;
+            if (!isDegeneratedCase)
+            {
+               thumbEnd -= (modelWidth - model.getLastVisible()) * interButtonLength / modelWidth;
+            }
+
+            int thumbPosX = buttonLongDim;
+            if (!isDegeneratedCase)
+            {
+               thumbPosX += interButtonLength * modelPosition / modelWidth;
+            }
+
+            int thumbWidth = thumbEnd - thumbPosX;
+
+            /**
+             * Test if the thumb is too narrow, try to handle this
+             */
+            final int thumbInflateNeeded = thumbMinWidth - thumbWidth;
+            if (thumbInflateNeeded > 0)
+            {
+               /**
+                * The 'true' calculated thumb width is to small to be usable, so we try
+                * to increase it.
+                */
+               /**
+                * Note: the check above guarantees, that the inter-button space here is wide enough
+                * to contain a thumb of a minimum thumb width.
+                */
+               thumbWidth = thumbMinWidth;
+               final int halfIncrease = thumbInflateNeeded / 2;
+               thumbPosX = Math.min(Math.max(thumbPosX - halfIncrease, 0),
+                        thumbEndLimit - thumbWidth);
+            }
+
+            if (localX < thumbPosX)
+            {
+               // Left area
+               rectLeft = buttonLongDim;
+               rectRight = thumbPosX;
+               lastHoverPart = Part.LEFT_AREA;
+            }
+            else if (localX < thumbPosX + thumbWidth)
+            {
+               // Thumb
+               rectLeft = thumbPosX;
+               rectRight = thumbPosX + thumbWidth;
+               lastHoverPart = Part.THUMB;
+            }
+            else
+            {
+               // Right area
+               rectLeft = thumbEndLimit;
+               rectRight = scrollBarWidth;
+               lastHoverPart = Part.RIGHT_AREA;
+            }
+         }
+      }
+
+      highLightedRect = new NativeRectangle(rectTop, rectLeft, rectTop + buttonShortDim,
+               rectRight).translate(p);
+   }
+
+   @Override
+   public void mousePressed(/* @Nullable */ MouseEvent e)
+   {
+      assert e != null;
+      final int x = e.getX();
+      final int y = e.getY();
+      lastMousePos = x;
+      lastModelPos = model.getPosition();
+      updateMouseHitInfo(x, y);
+      if (lastPressedPart != lastHoverPart)
+      {
+         lastPressedPart = lastHoverPart;
+         // FIXME: repaint rectangle instead of whole widget area
+         repaint();
+      }
+   }
+}

=== added file 'src/com/goldencode/p2j/ui/client/widget/LightweightWidget.java'
--- src/com/goldencode/p2j/ui/client/widget/LightweightWidget.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/widget/LightweightWidget.java	2021-06-09 19:11:07 +0000
@@ -0,0 +1,34 @@
+/**
+ * 
+ */
+package com.goldencode.p2j.ui.client.widget;
+
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+
+/**
+ * This class provides default implementations for a few {@link AbstractWidget} methods.
+ */
+abstract public class LightweightWidget extends AbstractWidget<GuiOutputManager>
+{
+
+   /**
+    * Default constructor.
+    */
+   public LightweightWidget()
+   {
+   }
+
+   @Override
+   public Dimension dimension()
+   {
+      return new Dimension(width(), height());
+   }
+
+   @Override
+   public Dimension minimumSize()
+   {
+      return dimension();
+   }
+
+}
\ No newline at end of file

=== added file 'src/com/goldencode/p2j/ui/client/widget/ScrollableContainer.java'
--- src/com/goldencode/p2j/ui/client/widget/ScrollableContainer.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/widget/ScrollableContainer.java	2021-06-10 18:42:08 +0000
@@ -0,0 +1,183 @@
+package com.goldencode.p2j.ui.client.widget;
+
+import com.goldencode.p2j.ui.*;
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+import com.goldencode.p2j.ui.client.model.*;
+
+/**
+ * This container widget wraps a child widget with two scrollbars.
+ *
+ */
+public class ScrollableContainer extends GenericContainer
+{
+   /**
+    * A widget to paint the corner between the scrollbars.
+    */
+   private GenericWidget corner = new GenericWidget()
+   {
+      @Override
+      public void draw()
+      {
+         NativePoint p = physicalLocation();
+         NativeDimension d = physicalDimension();
+         GuiDriver<?, ?> gd = (GuiDriver<?, ?>) OutputManager.getDriver();
+
+         gd.setColor(gd.getSysColor(SysColor.COLOR_SCROLLBAR));
+         gd.fillRect(p.x, p.y, d.width, d.height);
+      }
+   };
+
+   /**
+    * The horizontal scrollbar.
+    */
+   private AbstractScrollBar hBar;
+
+   /**
+    * The horizontal scrolling model.
+    */
+   private ScrollModel hModel;
+
+   /**
+    * The vertical scrollbar.
+    */
+   private AbstractScrollBar vBar;
+
+   /**
+    * The vertical scrolling model.
+    */
+   private ScrollModel vModel;
+
+   /**
+    * The managed widget. Must implement {@link I2DScrollable} interface.
+    */
+   private AbstractWidget<GuiOutputManager> widget;
+
+   public ScrollableContainer(final AbstractWidget<GuiOutputManager> widget, final ScrollModel hModel,
+            final ScrollModel vModel)
+   {
+      assert widget instanceof I2DScrollable;
+
+      this.hModel = hModel;
+      this.vModel = vModel;
+      this.widget = widget;
+      add(widget);
+      hBar = new HScrollBar(hModel);
+      add(hBar);
+      vBar = new VScrollBar(vModel);
+      add(vBar);
+      add(corner);
+   }
+
+   @Override
+   public void draw()
+   {
+      final NativePoint p = physicalLocation();
+      final NativeDimension d = physicalDimension();
+
+      final NativeRectangle clip = clipRectangle(p, d);
+
+      GuiDriver<?, ?> gd = (GuiDriver<?, ?>) OutputManager.getDriver();
+      gd.draw(p, clip, () -> {
+         for (Widget<GuiOutputManager> w : widgets())
+         {
+            if (w.isVisible())
+            {
+               w.draw();
+            }
+         }
+      });
+   }
+
+   @Override
+   public void doLayout()
+   {
+      final double containerHeight = height();
+      final double containerWidth = width();
+
+      final double hbHeight = hBar.minimumSize().height();
+      final double vbWidth = vBar.minimumSize().width();
+      corner.setSize(vbWidth, hbHeight);
+      corner.setLocation(containerWidth - vbWidth, containerHeight - hbHeight);
+
+      while (true)
+      {
+         double widgetWidth = containerWidth;
+         double widgetHeight = containerHeight;
+
+         final boolean hScrollAvailable = hModel.isScrollAvailable();
+         if (hScrollAvailable)
+         {
+            widgetHeight -= hbHeight;
+         }
+
+         final boolean vScrollAvailable = vModel.isScrollAvailable();
+         if (vScrollAvailable)
+         {
+            widgetWidth -= vbWidth;
+         }
+
+         if (hScrollAvailable)
+         {
+            final BaseConfig hbConfig = hBar.config();
+            hbConfig.widthChars = widgetWidth;
+            hbConfig.heightChars = hbHeight;
+            hBar.setLocation(0, widgetHeight);
+            hBar.show();
+         }
+         else
+         {
+            hBar.hide();
+         }
+
+         if (vScrollAvailable)
+         {
+            final BaseConfig vbConfig = vBar.config();
+            vbConfig.widthChars = vbWidth;
+            vbConfig.heightChars = widgetHeight;
+            vBar.setLocation(widgetWidth, 0);
+            vBar.show();
+         }
+         else
+         {
+            vBar.hide();
+         }
+
+         if (widget instanceof Container)
+         {
+            /**
+             * Note: this can lead to calling this doLayout() method recursively,
+             * this behavior is expected.
+             */
+            ((Container<?>) widget).setSize(widgetWidth, widgetHeight);
+         }
+         else
+         {
+            final BaseConfig widgetConfig = widget.config();
+            assert widgetConfig != null;
+            widgetConfig.widthChars = widgetWidth;
+            widgetConfig.heightChars = widgetHeight;
+         }
+
+         widget.setLocation(0, 0);
+
+         /**
+          * Note: we need to re-evaluate the scrollbar models availabilities here since they
+          * could have been changed in the above call to setSize(). 
+          */
+         corner.setVisible(hModel.isScrollAvailable() && vModel.isScrollAvailable());
+
+         I2DScrollable scrollableWidget = (I2DScrollable) widget;
+
+         /**
+          * Note: be sure both update procedures always called.
+          */
+         boolean changed = scrollableWidget.updateVScrollModel();
+         changed |= scrollableWidget.updateHScrollModel();
+         if (!changed)
+         {
+            return;
+         }
+      }
+   }
+}

